## linux-3.18 3.18.5

=== Makefile ===
VERSION = 3
PATCHLEVEL = 18
SUBLEVEL = 5
EXTRAVERSION =
NAME = Diseased Newt

# *DOCUMENTATION*
# To see a list of typical targets execute "make help"
# More info can be located in ./README
# Comments in this file are targeted only to the developer, do not
# expect to learn how to build the kernel reading this file.

# Do not use make's built-in rules and variables
# (this increases performance and avoids hard-to-debug behaviour);
MAKEFLAGS += -rR

# Avoid funny character set dependencies
unexport LC_ALL
LC_COLLATE=C
LC_NUMERIC=C
export LC_COLLATE LC_NUMERIC

# Avoid interference with shell env settings
unexport GREP_OPTIONS

# We are using a recursive build, so we need to do a little thinking
# to get the ordering right.
#
# Most importantly: sub-Makefiles should only ever modify files in
# their own directory. If in some directory we have a dependency on
# a file in another dir (which doesn't happen often, but it's often
# unavoidable when linking the built-in.o targets which finally
# turn into vmlinux), we will call a sub make in that other dir, and
# after that we are sure that everything which is in that other dir
# is now up to date.
#
# The only cases where we need to modify files which have global
# effects are thus separated out and done before the recursive
# descending is started. They are now explicitly listed as the
# prepare rule.

# Beautify output
# ---------------------------------------------------------------------------
#
# Normally, we echo the whole command before executing it. By making
# that echo $($(quiet)$(cmd)), we now have the possibility to set
# $(quiet) to choose other forms of output instead, e.g.
#
#         quiet_cmd_cc_o_c = Compiling $(RELDIR)/$@
#         cmd_cc_o_c       = $(CC) $(c_flags) -c -o $@ $<
#
# If $(quiet) is empty, the whole command will be printed.
# If it is set to "quiet_", only the short version will be printed.
# If it is set to "silent_", nothing will be printed at all, since
# the variable $(silent_cmd_cc_o_c) doesn't exist.
#
# A simple variant is to prefix commands with $(Q) - that's useful
# for commands that shall be hidden in non-verbose mode.
#
#	$(Q)ln $@ :<
#
# If KBUILD_VERBOSE equals 0 then the above command will be hidden.
# If KBUILD_VERBOSE equals 1 then the above command is displayed.
#
# To put more focus on warnings, be less verbose as default
# Use 'make V=1' to see the full commands

ifeq ("$(origin V)", "command line")
  KBUILD_VERBOSE = $(V)
endif
ifndef KBUILD_VERBOSE
  KBUILD_VERBOSE = 0
endif

ifeq ($(KBUILD_VERBOSE),1)
  quiet =
  Q =
else
  quiet=quiet_
  Q = @
endif

# If the user is running make -s (silent mode), suppress echoing of
# commands

ifneq ($(filter 4.%,$(MAKE_VERSION)),)	# make-4
ifneq ($(filter %s ,$(firstword x$(MAKEFLAGS))),)
  quiet=silent_
endif
else					# make-3.8x
ifneq ($(filter s% -s%,$(MAKEFLAGS)),)
  quiet=silent_
endif
endif

export quiet Q KBUILD_VERBOSE

# kbuild supports saving output files in a separate directory.
# To locate output files in a separate directory two syntaxes are supported.
# In both cases the working directory must be the root of the kernel src.
# 1) O=
# Use "make O=dir/to/store/output/files/"
#
# 2) Set KBUILD_OUTPUT
# Set the environment variable KBUILD_OUTPUT to point to the directory
# where the output files shall be placed.
# export KBUILD_OUTPUT=dir/to/store/output/files/
# make
#
# The O= assignment takes precedence over the KBUILD_OUTPUT environment
# variable.

# KBUILD_SRC is set on invocation of make in OBJ directory
# KBUILD_SRC is not intended to be used by the regular user (for now)
ifeq ($(KBUILD_SRC),)

# OK, Make called in directory where kernel src resides
# Do we want to locate output files in a separate directory?
ifeq ("$(origin O)", "command line")
  KBUILD_OUTPUT := $(O)
endif

# That's our default target when none is given on the command line
PHONY := _all
_all:

# Cancel implicit rules on top Makefile
$(CURDIR)/Makefile Makefile: ;

ifneq ($(KBUILD_OUTPUT),)
# Invoke a second make in the output directory, passing relevant variables
# check that the output directory actually exists
saved-output := $(KBUILD_OUTPUT)
KBUILD_OUTPUT := $(shell mkdir -p $(KBUILD_OUTPUT) && cd $(KBUILD_OUTPUT) \
								&& /bin/pwd)
$(if $(KBUILD_OUTPUT),, \
     $(error failed to create output directory "$(saved-output)"))

PHONY += $(MAKECMDGOALS) sub-make

$(filter-out _all sub-make $(CURDIR)/Makefile, $(MAKECMDGOALS)) _all: sub-make
	@:

sub-make: FORCE
	$(Q)$(MAKE) -C $(KBUILD_OUTPUT) KBUILD_SRC=$(CURDIR) \
	-f $(CURDIR)/Makefile $(filter-out _all sub-make,$(MAKECMDGOALS))

# Leave processing to above invocation of make
skip-makefile := 1
endif # ifneq ($(KBUILD_OUTPUT),)
endif # ifeq ($(KBUILD_SRC),)

# We process the rest of the Makefile if this is the final invocation of make
ifeq ($(skip-makefile),)

# Do not print "Entering directory ...",
# but we want to display it when entering to the output directory
# so that IDEs/editors are able to understand relative filenames.
MAKEFLAGS += --no-print-directory

# Call a source code checker (by default, "sparse") as part of the
# C compilation.
#
# Use 'make C=1' to enable checking of only re-compiled files.
# Use 'make C=2' to enable checking of *all* source files, regardless
# of whether they are re-compiled or not.
#
# See the file "Documentation/sparse.txt" for more details, including
# where to get the "sparse" utility.

ifeq ("$(origin C)", "command line")
  KBUILD_CHECKSRC = $(C)
endif
ifndef KBUILD_CHECKSRC
  KBUILD_CHECKSRC = 0
endif

# Use make M=dir to specify directory of external module to build
# Old syntax make ... SUBDIRS=$PWD is still supported
# Setting the environment variable KBUILD_EXTMOD take precedence
ifdef SUBDIRS
  KBUILD_EXTMOD ?= $(SUBDIRS)
endif

ifeq ("$(origin M)", "command line")
  KBUILD_EXTMOD := $(M)
endif

# If building an external module we do not care about the all: rule
# but instead _all depend on modules
PHONY += all
ifeq ($(KBUILD_EXTMOD),)
_all: all
else
_all: modules
endif

ifeq ($(KBUILD_SRC),)
        # building in the source tree
        srctree := .
else
        ifeq ($(KBUILD_SRC)/,$(dir $(CURDIR)))
                # building in a subdirectory of the source tree
                srctree := ..
        else
                srctree := $(KBUILD_SRC)
        endif
endif
objtree		:= .
src		:= $(srctree)
obj		:= $(objtree)

VPATH		:= $(srctree)$(if $(KBUILD_EXTMOD),:$(KBUILD_EXTMOD))

export srctree objtree VPATH


# SUBARCH tells the usermode build what the underlying arch is.  That is set
# first, and if a usermode build is happening, the "ARCH=um" on the command
# line overrides the setting of ARCH below.  If a native build is happening,
# then ARCH is assigned, getting whatever value it gets normally, and
# SUBARCH is subsequently ignored.

SUBARCH := $(shell uname -m | sed -e s/i.86/x86/ -e s/x86_64/x86/ \
				  -e s/sun4u/sparc64/ \
				  -e s/arm.*/arm/ -e s/sa110/arm/ \
				  -e s/s390x/s390/ -e s/parisc64/parisc/ \
				  -e s/ppc.*/powerpc/ -e s/mips.*/mips/ \
				  -e s/sh[234].*/sh/ -e s/aarch64.*/arm64/ )

# Cross compiling and selecting different set of gcc/bin-utils
# ---------------------------------------------------------------------------
#
# When performing cross compilation for other architectures ARCH shall be set
# to the target architecture. (See arch/* for the possibilities).
# ARCH can be set during invocation of make:
# make ARCH=ia64
# Another way is to have ARCH set in the environment.
# The default ARCH is the host where make is executed.

# CROSS_COMPILE specify the prefix used for all executables used
# during compilation. Only gcc and related bin-utils executables
# are prefixed with $(CROSS_COMPILE).
# CROSS_COMPILE can be set on the command line
# make CROSS_COMPILE=ia64-linux-
# Alternatively CROSS_COMPILE can be set in the environment.
# A third alternative is to store a setting in .config so that plain
# "make" in the configured kernel build directory always uses that.
# Default value for CROSS_COMPILE is not to prefix executables
# Note: Some architectures assign CROSS_COMPILE in their arch/*/Makefile
ARCH		?= $(SUBARCH)
CROSS_COMPILE	?= $(CONFIG_CROSS_COMPILE:"%"=%)

# Architecture as present in compile.h
UTS_MACHINE 	:= $(ARCH)
SRCARCH 	:= $(ARCH)

# Additional ARCH settings for x86
ifeq ($(ARCH),i386)
        SRCARCH := x86
endif
ifeq ($(ARCH),x86_64)
        SRCARCH := x86
endif

# Additional ARCH settings for sparc
ifeq ($(ARCH),sparc32)
       SRCARCH := sparc
endif
ifeq ($(ARCH),sparc64)
       SRCARCH := sparc
endif

# Additional ARCH settings for sh
ifeq ($(ARCH),sh64)
       SRCARCH := sh
endif

# Additional ARCH settings for tile
ifeq ($(ARCH),tilepro)
       SRCARCH := tile
endif
ifeq ($(ARCH),tilegx)
       SRCARCH := tile
endif

# Where to locate arch specific headers
hdr-arch  := $(SRCARCH)

KCONFIG_CONFIG	?= .config
export KCONFIG_CONFIG

# SHELL used by kbuild
CONFIG_SHELL := $(shell if [ -x "$$BASH" ]; then echo $$BASH; \
	  else if [ -x /bin/bash ]; then echo /bin/bash; \
	  else echo sh; fi ; fi)

HOSTCC       = gcc
HOSTCXX      = g++
HOSTCFLAGS   = -Wall -Wmissing-prototypes -Wstrict-prototypes -O2 -fomit-frame-pointer -std=gnu89
HOSTCXXFLAGS = -O2

ifeq ($(shell $(HOSTCC) -v 2>&1 | grep -c "clang version"), 1)
HOSTCFLAGS  += -Wno-unused-value -Wno-unused-parameter \
		-Wno-missing-field-initializers -fno-delete-null-pointer-checks
endif

# Decide whether to build built-in, modular, or both.
# Normally, just do built-in.

KBUILD_MODULES :=
KBUILD_BUILTIN := 1

# If we have only "make modules", don't compile built-in objects.
# When we're building modules with modversions, we need to consider
# the built-in objects during the descend as well, in order to
# make sure the checksums are up to date before we record them.

ifeq ($(MAKECMDGOALS),modules)
  KBUILD_BUILTIN := $(if $(CONFIG_MODVERSIONS),1)
endif

# If we have "make <whatever> modules", compile modules
# in addition to whatever we do anyway.
# Just "make" or "make all" shall build modules as well

ifneq ($(filter all _all modules,$(MAKECMDGOALS)),)
  KBUILD_MODULES := 1
endif

ifeq ($(MAKECMDGOALS),)
  KBUILD_MODULES := 1
endif

export KBUILD_MODULES KBUILD_BUILTIN
export KBUILD_CHECKSRC KBUILD_SRC KBUILD_EXTMOD

ifneq ($(CC),)
ifeq ($(shell $(CC) -v 2>&1 | grep -c "clang version"), 1)
COMPILER := clang
else
COMPILER := gcc
endif
export COMPILER
endif

# Look for make include files relative to root of kernel src
MAKEFLAGS += --include-dir=$(srctree)

# We need some generic definitions (do not try to remake the file).
$(srctree)/scripts/Kbuild.include: ;
include $(srctree)/scripts/Kbuild.include

# Make variables (CC, etc...)
AS		= $(CROSS_COMPILE)as
LD		= $(CROSS_COMPILE)ld
CC		= $(CROSS_COMPILE)gcc
CPP		= $(CC) -E
AR		= $(CROSS_COMPILE)ar
NM		= $(CROSS_COMPILE)nm
STRIP		= $(CROSS_COMPILE)strip
OBJCOPY		= $(CROSS_COMPILE)objcopy
OBJDUMP		= $(CROSS_COMPILE)objdump
AWK		= awk
GENKSYMS	= scripts/genksyms/genksyms
INSTALLKERNEL  := installkernel
DEPMOD		= /sbin/depmod
PERL		= perl
PYTHON		= python
CHECK		= sparse

CHECKFLAGS     := -D__linux__ -Dlinux -D__STDC__ -Dunix -D__unix__ \
		  -Wbitwise -Wno-return-void $(CF)
CFLAGS_MODULE   =
AFLAGS_MODULE   =
LDFLAGS_MODULE  =
CFLAGS_KERNEL	=
AFLAGS_KERNEL	=
CFLAGS_GCOV	= -fprofile-arcs -ftest-coverage


# Use USERINCLUDE when you must reference the UAPI directories only.
USERINCLUDE    := \
		-I$(srctree)/arch/$(hdr-arch)/include/uapi \
		-Iarch/$(hdr-arch)/include/generated/uapi \
		-I$(srctree)/include/uapi \
		-Iinclude/generated/uapi \
                -include $(srctree)/include/linux/kconfig.h

# Use LINUXINCLUDE when you must reference the include/ directory.
# Needed to be compatible with the O= option
LINUXINCLUDE    := \
		-I$(srctree)/arch/$(hdr-arch)/include \
		-Iarch/$(hdr-arch)/include/generated \
		$(if $(KBUILD_SRC), -I$(srctree)/include) \
		-Iinclude \
		$(USERINCLUDE)

KBUILD_CPPFLAGS := -D__KERNEL__

KBUILD_CFLAGS   := -Wall -Wundef -Wstrict-prototypes -Wno-trigraphs \

=== debian/changelog ===
linux-3.18 (3.18.5-1~exp1+rpi19+stretch) stretch-staging; urgency=medium

  * Re-enable linux-libc-dev

 -- Peter Michael Green <plugwash@raspbian.org>  Wed, 14 Oct 2015 23:24:50 +0000

linux-3.18 (3.18.5-1~exp1+rpi19) wheezy-staging; urgency=low

  * Revert config changes from previous version, they didn't help
  * Downgrade rpi patches to match foundation raspberrypi-bootloader package.

 -- Peter Michael Green <plugwash@raspbian.org>  Sat, 08 Aug 2015 16:52:15 +0000

linux-3.18 (3.18.5-1~exp1+rpi18) wheezy-staging; urgency=low

  * Add a load of rpf config settings for troubleshooting.

 -- Peter Michael Green <plugwash@raspbian.org>  Sat, 08 Aug 2015 12:09:30 +0000

linux-3.18 (3.18.5-1~exp1+rpi17) wheezy-staging; urgency=low

  * Add RTC drivers requested by Diederik
  * Update rpi patches.
  * Update mmc/dma settings to hopefully fix build failure.

 -- Peter Michael Green <plugwash@raspbian.org>  Sat, 25 Jul 2015 11:14:08 +0000

linux-3.18 (3.18.5-1~exp1+rpi16) wheezy-staging; urgency=low

  * Update rpi patches.

 -- Peter Michael Green <plugwash@raspbian.org>  Sat, 28 Mar 2015 04:28:36 +0000

linux-3.18 (3.18.5-1~exp1+rpi15) wheezy-staging; urgency=low

  * The debug patch from phil mysteriously fixed the boot issue. Assuming
    it stays fixed that means I can upload this version.
    + for reference the boot issue in +rpi13  was only seen on the model B
      (not the B+) and was only seen when booting with an initrd. It also
      appeared to impact rpf kernels when booting with the same initrd.
  * Update rpi patches.

 -- Peter Michael Green <plugwash@raspbian.org>  Sat, 07 Mar 2015 01:35:54 +0000

linux-3.18 (3.18.5-1~exp1+rpi14) wheezy-staging; urgency=low

  * Revert changes from -12 and -13, they didn't help.
    add patch to enable more debugging suggested by Phil Elwell

 -- Peter Michael Green <plugwash@raspbian.org>  Wed, 04 Mar 2015 20:52:10 +0000

linux-3.18 (3.18.5-1~exp1+rpi13) wheezy-staging; urgency=low

  * pi1 kernel still wasn't working in dt mode, try disabling most
    Debian-supplied patches.

 -- Peter Michael Green <plugwash@raspbian.org>  Tue, 17 Feb 2015 23:58:22 +0000

linux-3.18 (3.18.5-1~exp1+rpi12) wheezy-staging; urgency=low

  * Unfortunately it turns out that while the pi2 kernel works fine
    in both DT and non-DT mode the pi1 kernel only works in non-dt
    mode. Again bring in all the rpfs config settings to test
    (and if it works begin bisection)

 -- Peter Michael Green <plugwash@raspbian.org>  Mon, 16 Feb 2015 00:15:22 +0000

linux-3.18 (3.18.5-1~exp1+rpi11) wheezy-staging; urgency=low

  * add copyright header to mkknling.
  * enable I2S modules now we have device tree support.

 -- Peter Michael Green <plugwash@raspbian.org>  Sun, 15 Feb 2015 14:08:20 +0000

linux-3.18 (3.18.5-1~exp1+rpi10) wheezy-staging; urgency=low

  * keyboard continued to work in rpi9, bisection process done
    remove shelved config.
  * add device tree trailer using rpf's https://github.com/raspberrypi/tools/blob/master/mkimage/mkknlimg
    (need to confirm copyright status of this before releasing)
  * split out config.rpix containing config containing settings that
    are used for both pi1 and pi2.

 -- Peter Michael Green <plugwash@raspbian.org>  Fri, 13 Feb 2015 22:37:02 +0000

linux-3.18 (3.18.5-1~exp1+rpi9) wheezy-staging; urgency=low

  * keyboard worked in +rpi8, remove other configuration settings added
    for config-bisection process and copy config changes from rpi2 kernel to
    rpi kernel.

 -- Peter Michael Green <plugwash@raspbian.org>  Fri, 13 Feb 2015 13:06:55 +0000

linux-3.18 (3.18.5-1~exp1+rpi8) wheezy-staging; urgency=low

  * +rpi7 broke keyboard again, add back "regmap" and "cma" related config
    settings.

 -- Peter Michael Green <plugwash@raspbian.org>  Fri, 13 Feb 2015 02:41:23 +0000

linux-3.18 (3.18.5-1~exp1+rpi7) wheezy-staging; urgency=low

  * keyboard continued to work in rpi6, continue bisection.

 -- Peter Michael Green <plugwash@raspbian.org>  Thu, 12 Feb 2015 20:26:52 +0000

linux-3.18 (3.18.5-1~exp1+rpi6) wheezy-staging; urgency=low

  * keyboard continued to work in rpi5, continue bisection.

 -- Peter Michael Green <plugwash@raspbian.org>  Thu, 12 Feb 2015 13:28:29 +0000

linux-3.18 (3.18.5-1~exp1+rpi5) wheezy-staging; urgency=low

  * rpf config made the keyboard work, start config bisection process to
    determine which config setting is responsible.

 -- Peter Michael Green <plugwash@raspbian.org>  Thu, 12 Feb 2015 03:48:34 +0000

linux-3.18 (3.18.5-1~exp1+rpi4) wheezy-staging; urgency=low

  * temporerally try to make config identical to rpf one to test keyboard issue.

 -- Peter Michael Green <plugwash@raspbian.org>  Wed, 11 Feb 2015 21:17:04 +0000

linux-3.18 (3.18.5-1~exp1+rpi3) wheezy-staging; urgency=low

  * add more config stuff from rpf kernel, hopefull this will make my
    keyboard usable.
  * update rpi patches.

 -- Peter Michael Green <plugwash@raspbian.org>  Wed, 11 Feb 2015 03:08:15 +0000

linux-3.18 (3.18.5-1~exp1+rpi2) wheezy-staging; urgency=low

  * Take more config options from the rpf kernel, hopefully this will give
    us usable kernels (previous attempt booted but udev failed to start and
    keyboard was unusable).
  * Fix clean target

 -- Peter Michael Green <plugwash@raspbian.org>  Sat, 07 Feb 2015 15:36:20 +0000

linux-3.18 (3.18.5-1~exp1+rpi1) wheezy-staging; urgency=medium

  [Vagrant Cascadian <vagrant@debian.org>]
  * disable other armhf variants. 
  * disable other armhf debian-installer variants.
  * attempt to enable debian-installer udebs for rpi.
  * try harder to enable debian-installer udebs. 
  [Peter Michael Green]
  * Include patches to support RaspberryPI from:
    https://github.com/raspberrypi/linux.git
    branch: rpi-3.16.y
  * add script to automatically regenerate rpi patches from git repos
  * add hack to allow upgrading of kernel located on fat partition to succeed
  * Fix clean target
  * Merge config changes from 3.10.11-1+rpi4 packaging.


=== debian/control ===
Source: linux-3.18
Section: kernel
Priority: optional
Maintainer: Debian Kernel Team <debian-kernel@lists.debian.org>
Uploaders: Bastian Blank <waldi@debian.org>, Frederik Schüler <fs@debian.org>, maximilian attems <maks@debian.org>, Ben Hutchings <ben@decadent.org.uk>
Standards-Version: 3.9.5
Build-Depends: debhelper, cpio, kmod, python, python-six, lzma [armel], kernel-wedge, quilt, patchutils, bc, gcc-4.7 [alpha amd64 arm64 armel armhf hppa i386 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el sh4 sparc sparc64], gcc-4.6 [ia64], gcc-4.8 [m68k s390 s390x]
Build-Depends-Indep: xz-utils, xmlto
Vcs-Svn: svn://anonscm.debian.org/svn/kernel/dists/trunk/linux/
Vcs-Browser: http://anonscm.debian.org/viewvc/kernel/dists/trunk/linux/
Homepage: https://www.kernel.org/

Package: linux-source-3.18
Architecture: all
Section: kernel
Depends: binutils, bzip2, ${misc:Depends}
Recommends: libc6-dev | libc-dev, gcc, make, bc
Suggests: libncurses-dev | ncurses-dev, libqt4-dev, pkg-config
Description: Linux kernel source for version 3.18 with Debian patches
 This package provides source code for the Linux kernel version 3.18. This
 source closely tracks official Linux kernel releases.  Debian's
 modifications to that source consist of security fixes, bug fixes, and
 features that have already been (or are believed to be) accepted by the
 upstream maintainers.
Multi-Arch: foreign

Package: linux-doc-3.18
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Linux kernel specific documentation for version 3.18
 This package provides the various README files and HTML documentation for
 the Linux kernel version 3.18.  Plenty of information, including the
 descriptions of various kernel subsystems, filesystems, driver-specific
 notes and the like.  Consult the file
 /usr/share/doc/linux-doc-3.18/Documentation/00-INDEX for the detailed
 description of the contents.
Multi-Arch: foreign

Package: linux-manual-3.18
Architecture: all
Section: doc
Provides: linux-manual
Depends: ${misc:Depends}
Replaces: linux-manual
Conflicts: linux-manual
Description: Linux kernel API manual pages for version 3.18
 This package provides the Kernel Hacker's Guide in the form of manual
 pages, describing the kernel API functions.  They are installed into
 section 9 of the manual.
 .
 As the files containing manual pages for different kernel versions are
 installed in the same location, only one linux-manual package may be
 installed at a time.  The linux-doc package containing the documentation
 in other formats is free from such restriction.
Multi-Arch: foreign

Package: linux-support-3.18.0-trunk
Architecture: all
Section: devel
Depends: ${python:Depends}, ${misc:Depends}, python-six
Description: Support files for Linux 3.18
 This package provides support files for the Linux kernel build, e.g.
 scripts to handle ABI information and for generation of build system meta
 data.
Multi-Arch: foreign

Package: linux-libc-dev
Architecture: alpha amd64 arm64 armel armhf hppa i386 ia64 m68k mips mips64 mips64el mipsel or1k powerpc powerpcspe ppc64 ppc64el s390 s390x sh4 sparc sparc64 x32
Section: devel
Provides: linux-kernel-headers
Depends: ${misc:Depends}
Replaces: linux-kernel-headers
Conflicts: linux-kernel-headers
Description: Linux support headers for userspace development
 This package provides userspaces headers from the Linux kernel.  These
 headers are used by the installed headers for GNU libc and other system
 libraries.
Multi-Arch: same

Package: linux-headers-3.18.0-trunk-all
Architecture: alpha amd64 arm64 armel armhf hppa i386 ia64 m68k mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el s390 s390x sh4 sparc sparc64
Depends: linux-headers-3.18.0-trunk-all-${kernel:Arch} (= ${binary:Version}), ${misc:Depends}
Description: All header files for Linux 3.18 (meta-package)
 This package depends against all architecture-specific kernel header files
 for Linux kernel version 3.18, generally used for building out-of-tree
 kernel modules.

Package: linux-headers-3.18.0-trunk-all-alpha
Architecture: alpha
Depends: ${misc:Depends}, linux-headers-3.18.0-trunk-alpha-generic (= ${binary:Version}), linux-headers-3.18.0-trunk-alpha-smp (= ${binary:Version}), linux-headers-3.18.0-trunk-alpha-legacy (= ${binary:Version})
Description: All header files for Linux 3.18 (meta-package)
 This package depends against all architecture-specific kernel header files
 for Linux kernel version 3.18, generally used for building out-of-tree
 kernel modules.

Package: linux-headers-3.18.0-trunk-common
Architecture: alpha amd64 arm64 armel armhf hppa i386 ia64 m68k mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el s390 s390x sh4 sparc sparc64
Depends: ${misc:Depends}
Description: Common header files for Linux 3.18.0-trunk
 This package provides the architecture-specific common kernel header files
 for Linux kernel version 3.18.0-trunk, generally used for building
 out-of-tree kernel modules.  To obtain a complete set of headers you also
 need to install the linux-headers-3.18.0-trunk-(flavour) package, matching
 the flavour of the kernel you intend the build for.

Package: linux-image-3.18.0-trunk-alpha-generic
Architecture: alpha
Provides: linux-modules-3.18.0-trunk-alpha-generic
Pre-Depends: debconf | debconf-2.0
Depends: kmod | module-init-tools, linux-base (>= 3~), ${misc:Depends}, initramfs-tools (>= 0.110~) [alpha] | linux-initramfs-tool [alpha]
Recommends: firmware-linux-free (>= 3~), ${kernel:Recommends}
Suggests: linux-doc-3.18, debian-kernel-handbook, aboot [alpha], fdutils [alpha]
Breaks: at (<< 3.1.12-1+squeeze1), initramfs-tools (<< 0.110~)
Description: Linux 3.18 for Alpha
 The Linux kernel 3.18 and modules for use on DEC Alpha systems with
 extended kernel start address (Wildfire, Titan, Marvel).

Package: linux-headers-3.18.0-trunk-alpha-generic
Architecture: alpha
Depends: linux-headers-3.18.0-trunk-common (= ${binary:Version}), linux-kbuild-3.18, ${misc:Depends}, gcc-4.7
Description: Header files for Linux 3.18.0-trunk-alpha-generic
 This package provides the architecture-specific kernel header files for
 Linux kernel 3.18.0-trunk-alpha-generic, generally used for building
 out-of-tree kernel modules.  These files are going to be installed into
 /usr/src/linux-headers-3.18.0-trunk-alpha-generic, and can be used for
 building modules that load into the kernel provided by the
 linux-image-3.18.0-trunk-alpha-generic package.

Package: linux-image-3.18.0-trunk-alpha-smp
Architecture: alpha
Provides: linux-modules-3.18.0-trunk-alpha-smp
Pre-Depends: debconf | debconf-2.0
Depends: kmod | module-init-tools, linux-base (>= 3~), ${misc:Depends}, initramfs-tools (>= 0.110~) [alpha] | linux-initramfs-tool [alpha]
Recommends: firmware-linux-free (>= 3~), ${kernel:Recommends}
Suggests: linux-doc-3.18, debian-kernel-handbook, aboot [alpha], fdutils [alpha]
Breaks: at (<< 3.1.12-1+squeeze1), initramfs-tools (<< 0.110~)
Description: Linux 3.18 for Alpha SMP
 The Linux kernel 3.18 and modules for use on DEC Alpha SMP systems with
 extended kernel start address (Wildfire, Titan, Marvel).

Package: linux-headers-3.18.0-trunk-alpha-smp
Architecture: alpha
Depends: linux-headers-3.18.0-trunk-common (= ${binary:Version}), linux-kbuild-3.18, ${misc:Depends}, gcc-4.7
Description: Header files for Linux 3.18.0-trunk-alpha-smp
 This package provides the architecture-specific kernel header files for
 Linux kernel 3.18.0-trunk-alpha-smp, generally used for building
 out-of-tree kernel modules.  These files are going to be installed into
 /usr/src/linux-headers-3.18.0-trunk-alpha-smp, and can be used for
 building modules that load into the kernel provided by the
 linux-image-3.18.0-trunk-alpha-smp package.

Package: linux-image-3.18.0-trunk-alpha-legacy
Architecture: alpha
Provides: linux-modules-3.18.0-trunk-alpha-legacy
Pre-Depends: debconf | debconf-2.0
Depends: kmod | module-init-tools, linux-base (>= 3~), ${misc:Depends}, initramfs-tools (>= 0.110~) [alpha] | linux-initramfs-tool [alpha]
Recommends: firmware-linux-free (>= 3~), ${kernel:Recommends}
Suggests: linux-doc-3.18, debian-kernel-handbook, aboot [alpha], fdutils [alpha]
Breaks: at (<< 3.1.12-1+squeeze1), initramfs-tools (<< 0.110~)
Description: Linux 3.18 for Alpha Legacy
 The Linux kernel 3.18 and modules for use on DEC Alpha systems with legacy
 kernel start address.

Package: linux-headers-3.18.0-trunk-alpha-legacy
Architecture: alpha
Depends: linux-headers-3.18.0-trunk-common (= ${binary:Version}), linux-kbuild-3.18, ${misc:Depends}, gcc-4.7
Description: Header files for Linux 3.18.0-trunk-alpha-legacy
 This package provides the architecture-specific kernel header files for
 Linux kernel 3.18.0-trunk-alpha-legacy, generally used for building
 out-of-tree kernel modules.  These files are going to be installed into
 /usr/src/linux-headers-3.18.0-trunk-alpha-legacy, and can be used for
 building modules that load into the kernel provided by the
 linux-image-3.18.0-trunk-alpha-legacy package.

Package: linux-headers-3.18.0-trunk-all-amd64
Architecture: amd64
Depends: ${misc:Depends}, linux-headers-3.18.0-trunk-amd64 (= ${binary:Version})
Description: All header files for Linux 3.18 (meta-package)
 This package depends against all architecture-specific kernel header files
 for Linux kernel version 3.18, generally used for building out-of-tree
 kernel modules.

Package: kernel-image-3.18.0-trunk-amd64-di
Architecture: amd64
Section: debian-installer
Priority: extra
Provides: kernel-image, zlib-modules
Description: Linux kernel binary image for the Debian installer
 This package contains the kernel image for the Debian installer boot
 images.  It does _not_ provide a usable kernel for your full Debian
 system.
Kernel-Version: 3.18.0-trunk-amd64
Package-Type: udeb

Package: nic-modules-3.18.0-trunk-amd64-di
Architecture: amd64
Section: debian-installer
Priority: standard
Provides: nic-modules, nic-extra-modules
Depends: kernel-image-3.18.0-trunk-amd64-di, nic-shared-modules-3.18.0-trunk-amd64-di, core-modules-3.18.0-trunk-amd64-di, i2c-modules-3.18.0-trunk-amd64-di, crc-modules-3.18.0-trunk-amd64-di
Description: NIC drivers
 This package contains Ethernet and some paravirtualised network drivers
 for the kernel.
Kernel-Version: 3.18.0-trunk-amd64
Package-Type: udeb

Package: nic-wireless-modules-3.18.0-trunk-amd64-di
Architecture: amd64
Section: debian-installer
Priority: standard
Provides: nic-wireless-modules
Depends: kernel-image-3.18.0-trunk-amd64-di, nic-shared-modules-3.18.0-trunk-amd64-di, core-modules-3.18.0-trunk-amd64-di, usb-modules-3.18.0-trunk-amd64-di, mmc-modules-3.18.0-trunk-amd64-di, pcmcia-modules-3.18.0-trunk-amd64-di, crc-modules-3.18.0-trunk-amd64-di
Description: Wireless NIC drivers
 This package contains wireless NIC drivers for the kernel.  Includes
 crypto modules only needed for wireless (WEP, WPA).
Kernel-Version: 3.18.0-trunk-amd64
Package-Type: udeb

Package: nic-shared-modules-3.18.0-trunk-amd64-di
Architecture: amd64
Section: debian-installer
Priority: standard
Provides: nic-shared-modules
Depends: kernel-image-3.18.0-trunk-amd64-di
Description: Shared NIC drivers
 This package contains NIC drivers needed by combinations of nic-modules,
 nic-pcmcia-modules, nic-usb-modules and nic-wireless-modules.
Kernel-Version: 3.18.0-trunk-amd64
Package-Type: udeb

Package: serial-modules-3.18.0-trunk-amd64-di
Architecture: amd64
Section: debian-installer
Priority: optional
Provides: serial-modules
Depends: kernel-image-3.18.0-trunk-amd64-di, pcmcia-modules-3.18.0-trunk-amd64-di
Description: Serial drivers
 This package contains serial drivers for the kernel.
Kernel-Version: 3.18.0-trunk-amd64
Package-Type: udeb

Package: usb-serial-modules-3.18.0-trunk-amd64-di
Architecture: amd64
Section: debian-installer
Priority: optional
Provides: usb-serial-modules
Depends: kernel-image-3.18.0-trunk-amd64-di, usb-modules-3.18.0-trunk-amd64-di
Description: USB serial drivers
 This package contains USB serial drivers for the kernel.

=== debian/rules ===
#!/usr/bin/make -f

SHELL    := sh -e
DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
SOURCE := $(shell dpkg-parsechangelog | sed -ne 's,^Source: *\(.*\)$$,\1,p')
VERSION := $(shell dpkg-parsechangelog | sed -ne 's,^Version: *\(.*\)$$,\1,p')
VERSION_UPSTREAM := $(shell echo "$(VERSION)" | sed -e 's,-[^-]*$$,,')
VERSION_BINNMU := $(shell echo "$(VERSION)" | sed -ne 's,.*+b\(.*\)$$,\1,p')

include debian/rules.defs

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  DEBIAN_KERNEL_JOBS := $(subst parallel=,,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif
ifdef DEBIAN_KERNEL_JOBS
  MAKEFLAGS += -j$(DEBIAN_KERNEL_JOBS)
endif

.NOTPARALLEL:

source: debian/control
	dh_testdir
	$(MAKE) -f debian/rules.gen source

setup: debian/control
	dh_testdir
	$(MAKE) -f debian/rules.gen setup_$(DEB_HOST_ARCH)

build: build-arch build-indep

build-arch: debian/control
	dh_testdir
	$(MAKE) -f debian/rules.gen build-arch_$(DEB_HOST_ARCH)

build-indep: debian/control
	dh_testdir
	$(MAKE) -f debian/rules.gen build-indep

binary:	binary-indep binary-arch

binary-arch:
	dh_testdir
	$(MAKE) -f debian/rules.gen binary-arch_$(DEB_HOST_ARCH)

binary-indep:
	dh_testdir
	$(MAKE) -f debian/rules.gen binary-indep

DIR_ORIG = ../orig/$(SOURCE)-$(VERSION_UPSTREAM)
TAR_ORIG_NAME = $(SOURCE)_$(VERSION_UPSTREAM).orig.tar.xz
TAR_ORIG = $(firstword $(wildcard ../$(TAR_ORIG_NAME)) $(wildcard ../orig/$(TAR_ORIG_NAME)))

orig: $(DIR_ORIG)
	rsync --delete --exclude /debian --exclude .svk --exclude .svn --exclude .git --link-dest=$(DIR_ORIG)/ -a $(DIR_ORIG)/ .
	QUILT_PATCHES='$(CURDIR)/debian/patches' QUILT_PC=.pc quilt push --quiltrc - -a -q --fuzz=0

$(DIR_ORIG):
ifeq ($(TAR_ORIG),)
	$(error Cannot find orig tarball $(TAR_ORIG_NAME))
else
	mkdir -p ../orig
	tar -C ../orig -xaf $(TAR_ORIG)
endif

maintainerclean:
	rm -f debian/config.defines.dump debian/control debian/control.md5sum debian/linux-* debian/rules.gen debian/po/*.po
	rm -rf $(filter-out debian .svk .svn .git, $(wildcard * .[^.]*))

clean: debian/control
	dh_testdir
	rm -rf $(BUILD_DIR) $(STAMPS_DIR) debian/lib/python/debian_linux/*.pyc debian/lib/python/debian_linux/__pycache__ $$(find debian -maxdepth 1 -type d -name 'linux-*') debian/*-modules-*-di* debian/kernel-image-*-di* debian/xen-linux-system-*
	dh_clean
	rm -f arch/s390/include/asm/cmb.h.1
	rm -f drivers/acpi/scan.c.1
	rm -f drivers/base/reservation.c.1
	rm -f drivers/usb/gadget/f_acm.c.1
	rm -f drivers/usb/gadget/f_ecm.c.1
	rm -f drivers/usb/gadget/f_obex.c.1
	rm -f drivers/usb/gadget/f_serial.c.1
	rm -f drivers/usb/gadget/f_subset.c.1
	rm -f include/linux/reservation.h.1
	rm -f include/net/cfg80211.h.1
	rm -f kernel/sys.c.1
	rm -f lib/crc32.c.1
	rm -f drivers/dma-buf/reservation.c.1
	rm -f drivers/dma-buf/seqno-fence.c.1
	rm -f drivers/usb/gadget/function/f_acm.c.1
	rm -f drivers/usb/gadget/function/f_ecm.c.1
	rm -f drivers/usb/gadget/function/f_obex.c.1
	rm -f drivers/usb/gadget/function/f_serial.c.1
	rm -f drivers/usb/gadget/function/f_subset.c.1



CONTROL_FILES = debian/changelog $(wildcard debian/templates/*.in)
CONTROL_FILES += debian/config/defines $(wildcard debian/config/*/defines) $(wildcard debian/config/*/*/defines)
CONTROL_FILES += $(wildcard debian/installer/*/kernel-versions) $(wildcard debian/installer/*/package-list) debian/installer/package-list
debian/control debian/rules.gen: debian/bin/gencontrol.py $(CONTROL_FILES)
ifeq ($(wildcard debian/control.md5sum),)
	$(MAKE) -f debian/rules debian/control-real
else ifeq ($(VERSION_BINNMU),)
	md5sum --check debian/control.md5sum --status || \
		$(MAKE) -f debian/rules debian/control-real
else
	grep -v debian/changelog debian/control.md5sum | md5sum --check - --status || \
		$(MAKE) -f debian/rules debian/control-real
endif

debian/control-real: debian/bin/gencontrol.py $(CONTROL_FILES)
	$<
	md5sum $^ > debian/control.md5sum
	@echo
	@echo This target is made to fail intentionally, to make sure
	@echo that it is NEVER run during the automated build. Please
	@echo ignore the following error, the debian/control file has
	@echo been generated SUCCESSFULLY.
	@echo
	exit 1

.PHONY: clean build setup binary-indep binary-arch binary
